<?
class Kreisdiagramm
{
    function init($init)
    {
    	$file  = $init[output_file];
    	$werte = $init[werte];
        
        $img_width	= $init[breite];
        $img_heigth = $init[hoehe];
        $img = imagecreate($img_width, $img_heigth);

        
        $backgroundcolor = $this -> convert_html_to_rgb_color($init[bgcolor]);       
        $bordercolor     = $this -> convert_html_to_rgb_color($init[bordercolor]);  
        $textcolor       = $this -> convert_html_to_rgb_color($init[textcolor]);   
		$shadowcolor	 = $this -> convert_html_to_rgb_color($init[shadowcolor]);  

        $background_color = ImageColorAllocate ($img ,$backgroundcolor[0] ,$backgroundcolor[1] ,$backgroundcolor[2]  );
        if($init[transparent] == 1)
        {
			imagecolortransparent($img, $background_color);
        }
        $text_color       = ImageColorAllocate ($img ,$textcolor[0]       ,$textcolor[1]       ,$textcolor[2]        );
        $border_color     = ImageColorAllocate ($img ,$bordercolor[0]     ,$bordercolor[1]     ,$bordercolor[2]      );
        $shadow_color     = ImageColorAllocate ($img ,$shadowcolor[0]     ,$shadowcolor[1]     ,$shadowcolor[2]      );

       
        imageline($img, 5, 5, $img_width - 5, 5, $border_color);                                  	
        imageline($img, 5, 25, $img_width - 5, 25, $border_color);                              	
        imageline($img, 5, $img_heigth - 5, 5, 5, $border_color);                          			
        imageline($img, 5, $img_heigth - 5, $img_width - 5 , $img_heigth - 5, $border_color);    	
        imageline($img, $img_width - 5, $img_heigth - 5, $img_width - 5 , 5, $border_color);    

       
        imagestring  ($img, 4, 8, 8, $init[name], $text_color);                                    

		
		$small_circle_radius = $img_heigth/1.3;

		imagearc($img,  $img_heigth/2.8 + 20, $img_heigth/2, $small_circle_radius , $small_circle_radius, 0,360, $border_color);
		imagearc($img,  $img_heigth/2.8 + 20, $img_heigth/2 + 10, $small_circle_radius  , $small_circle_radius, 0,180 , $border_color);
		imagefill($img, $img_heigth/2.8 + 20, $img_heigth/2 + 8 + $small_circle_radius / 2, $shadow_color);

		foreach($werte as $wert) { $all_added_values += $wert; }

		$x = 0;
		foreach($werte as $wert)
		{
			if($wert != 0)
			{
				$percentage = $wert / $all_added_values * 100;
				$all_values[] = array(
					value	=> $percentage,
					descr	=> $init[descr][$x],
					color	=> $init[color][$x],
				);
			}
			$x++;
		}
		if($init[sort] == 1)
		{
			rsort($all_values);
		}
		$start_angle = 0;
		$pic_middle_x = $img_heigth/2.8 + 20;
		$pic_middle_y = $img_heigth/2;
		$x = 0;
		foreach ($all_values as $value_array)
		{
				$tmp_color = $this -> convert_html_to_rgb_color($value_array[color]);
				$color     = ImageColorAllocate ($img ,$tmp_color[0] ,$tmp_color[1] ,$tmp_color[2]);

				$end_angle = 3.6 * $value_array[value] + $start_angle;

				$x_k  = $pic_middle_x + ($small_circle_radius/2 * (cos(deg2rad(-$start_angle))));
				$y_k  = $pic_middle_y + ($small_circle_radius/2 * (sin(deg2rad(-$start_angle))));

				$x_k2 = $pic_middle_x + ($small_circle_radius/2 * (cos(deg2rad(-$end_angle))));
				$y_k2 = $pic_middle_y + ($small_circle_radius/2 * (sin(deg2rad(-$end_angle))));

				$x_k3 = $pic_middle_x + ($small_circle_radius/2.2 * (cos(deg2rad(-$end_angle + 5))));
				$y_k3 = $pic_middle_y + ($small_circle_radius/2.2 * (sin(deg2rad(-$end_angle + 5))));

				imageline($img, $pic_middle_x, $pic_middle_y, $x_k2, $y_k2 , $border_color);
				imageline($img, $pic_middle_x, $pic_middle_y, $x_k2, $y_k2 , $border_color);
				imagefill($img,   $x_k3, $y_k3, $color);

				imagearc($img,  $small_circle_radius + 50, $x * 15 + 37, 8 , 6, 0,360, $color);
				imagefill($img, $small_circle_radius + 51, $x * 15 + 38, $color);

				if($value_array[value] < 10)
				{
					$user_perc = "(".number_format($value_array[value],0)." %) ";
				}
				else
				{
					$user_perc = "(".number_format($value_array[value],0)." %)";
				}
				imagestring  ($img, 4, $small_circle_radius + 60, $x * 15 + 30, $user_perc." ".$value_array[descr], $text_color);      # descr text
				$start_angle = $end_angle;
				$x++;
		}

        # sets content type to image/png
        if($file != "")
        {
            imagepng($img, $file);
        }
        else
        {
            header ("Content-type: image/png");
            imagepng($img);
        }
    }

  
    function convert_html_to_rgb_color($html_color)
    {
        $html_color = substr($html_color,1);
        #brake the html color in 3 segments
        $seg1 = hexdec(substr($html_color,0,2));
        $seg2 = hexdec(substr($html_color,2,2));
        $seg3 = hexdec(substr($html_color,4,2));
        $rgb_color = array("$seg1","$seg2","$seg3");
        return($rgb_color);
    }

    function die_richtig($temp)
    {
        print "<pre>"; print_r($temp); print "</pre>";   
        die("Kreisdiagramm(): kann mit diesen Werten kein Diagramm zeichnen");
    }
}
?>